<?php
namespace SM\Factory;

use Doctrine\ORM\EntityManager;
use SM\Traits\TQuery;

class CdaFactory
{

    use TQuery;

    protected $connection;
    protected $entityManager;

    public function __construct(EntityManager $entityManager)
    {
        $this->connection = $entityManager->getConnection();
        $this->entityManager = $entityManager;
    }

    public function getCda(array $params)
    {        
        $sql = "SELECT SERV.CDFILIAL,
                       TO_CHAR(DATA.DTDATA, 'DD/MM/YYYY') AS DATA,
                       DECODE(FERI.DTFERIFILI, NULL, 'S', 'N') AS IDDIAUTIL,
                       TO_CHAR(NVL(SERV.DTSERVPREST, DATA.DTDATA), 'DD/MM/YYYY') DTSERVPREST,
                       DATA.NMFUNC,
                       CASE WHEN PROS.CDPROSPECT IS NULL THEN CLIE.NMRAZSOCCLIE ELSE PROS.NMRAZSOCPROS END AS NMCLIEPROSP,
                       INTC.CDINTECLIE,
                       INTP.CDINTEPROS,
                       CASE WHEN PROS.CDPROSPECT IS NULL THEN INTC.NRTEL1INCLIE ELSE INTP.NRTEL1INPROS END AS NRTELINTCLPR,
                       CASE WHEN PROS.CDPROSPECT IS NULL THEN INTC.DSEMAILICLIE ELSE INTP.DSEMAILIPROS END AS DSEMAILINTCLPR,
                       CASE WHEN PROS.CDPROSPECT IS NULL THEN CLIE.NRPARCNEGOCIO ELSE PROS.NRPARCNEGOCIO END AS NRPARCNEGOCIO,
                       CLIE.NMFANTCLIE,
                       CLIE.NMRAZSOCCLIE,
                       PROS.NMFANTPROS,
                       PROS.NMRAZSOCPROS,
                       NVL(SERV.DSREFERENCIA, 'CDA - '||TO_CHAR(DATA.DTDATA, 'DD/MM/YYYY')) AS DSREFERENCIA,
                       DATA.CDEMPRESA,
                       DATA.CDFUNC,
                       SERV.CDCLIENTE,
                       PROS.CDPROSPECT,
                       SERV.NMINTCLIENTE,
                       SERV.NRLICENCAUSO,
                       LUSO.NMFANTLUSO,
                       CLIE.NRINSJURCLIE,
                       SERV.NRSERVCONT,
                       SERV.NRSEQAGESERV,
                       SERV.CDTIPOSERV,
                       TPSV.NMTIPOSERV,
                       SERV.IDSERVPREST AS IDSERVPREST_IN_GRID,
                       SERV.IDSERVPREST,
                       SERV.DTENTRADA,
                       DECODE(SERV.IDSERVPREST, 'FALTA_NAO_JUSTIFICADA', 'S', 'N') AS IDFALTA,
                       SERV.NRPROPOSFAS,
                       SERV.NRVERPROPFAS,
                       SERV.NRSEQUCHT,
                       NVL(SERV.IDSITSERVPREST,'P') AS IDSITSERVPREST,
                       PRO.CDPROJETO,
                       PRO.NMPROJETO,
                       NVL(SERV.NRSERVPREST, '00000') AS NRSERVPREST,
                       SERV.NRMOTIVOEXCEFREQ,
                       DECODE(PROP.NRPROPOSFAS, NULL, NULL, PROP.NRPROPOSFAS||'-'||PROP.NRVERPROPFAS) AS NR_VER_PROP,
                       PROP.DSREFEPROPOSFAS,
                       DATA.CDOPERADOR,
                       INTC.NMINTECLIE,
                       INTP.NMINTEPROS,
                       CONT.NRSEQCONTATO AS NRCONTATO,
                       CONT.DSREFECONT,
                       CONT.CDMOTICONT,
                       CONT.CDSISTEMA,
                       MOTC.NMMOTICONT,
                       EVOC.CDMOTIEVOCON,
                       MEVC.NMMOTIEVOCON,
                       EVOC.DSEVOLCONT,
                       EVOC.DTHREVOLCONT,
                       DECODE(DSSP.NRSERVPREST, NULL, 'N', 'S') AS IDDESCRICAOOK,
                       'S' AS IDATIVO,
                       PER.PERMISSAO,
                       DECODE(SERV.IDSERVPREST, NULL, 'N', 'S') AS IDEXISTSCDA,
                       CASE WHEN TRUNC(SYSDATE) - TRUNC(DATA.DTDATA) > 7
                            THEN 'S'
                            ELSE 'N' END AS IDLIMITEDIAS
                      FROM (SELECT :CDFILIAL AS CDFILIAL, FUNC.CDFILIALOCFUNC, FUNC.NRORG, FUNC.CDEMPRESA,  FUNC.CDFUNC, FUNC.NMFUNC, OPER.CDOPERADOR, DATA.DTDATA
                              FROM DATA, FUNCIONARIO FUNC, OPERADOR OPER
                             WHERE DATA.DTDATA BETWEEN TO_DATE(:DTINICIALPERIODO, 'DD/MM/YYYY') AND TO_DATE(:DTFINALPERIODO, 'DD/MM/YYYY')
                               AND FUNC.CDEMPRESA = :CDEMPRESA
                               AND FUNC.CDFUNC = :CDFUNC
                               AND FUNC.NRORG = :NRORG
                               AND FUNC.NRORG = OPER.NRORG
                               AND FUNC.CDEMPRESA = OPER.CDEMPRESA
                               AND FUNC.CDFUNC = OPER.CDFUNC) DATA,
                           SERVPREST SERV, CLIENTE CLIE, PROJETO PRO, FERIFILI FERI, PROSPECT PROS, LICENCAUSO LUSO, PROPOSTAFAS PROP, 
                           TIPOSERV TPSV, INTECLIE INTC, INTEPROSP INTP, CONTATO CONT, EVOLCONT EVOC, MOTICONT MOTC, MOTIEVOLCONT MEVC,
                           DESCSERVPRES DSSP,
                           (SELECT COUNT(*) AS PERMISSAO
                              FROM AUTGRUPOP
                             WHERE (IDAUTGRUPOP = 'DPAP' OR IDAUTGRUPOP = 'ACSA')
                               AND CDGRUPOPER IN (SELECT CDGRUPOPER
                                                    FROM OPERGRUPOP
                                                   WHERE CDOPERADOR = :CDOPERADOR)) PER
                     WHERE DATA.NRORG = SERV.NRORG(+)
                       AND DATA.CDEMPRESA = SERV.CDEMPRESA(+)
                       AND DATA.CDFUNC = SERV.CDFUNC(+)
                       AND DATA.DTDATA = SERV.DTSERVPREST(+)
                       AND DATA.NRORG = FERI.NRORG(+)
                       AND DATA.CDFILIALOCFUNC = FERI.CDFILIAL(+)
                       AND DATA.DTDATA = FERI.DTFERIFILI(+)
                       AND SERV.NRORG = CLIE.NRORG(+)
                       AND SERV.CDCLIENTE = CLIE.CDCLIENTE(+)
                       AND SERV.NRORG = PRO.NRORG(+)
                       AND SERV.CDPROJETO = PRO.CDPROJETO(+)
                       AND SERV.NRORG = PROS.NRORG(+)
                       AND SERV.CDPROSPECT = PROS.CDPROSPECT(+)
                       AND SERV.NRORG = LUSO.NRORG(+)
                       AND SERV.CDCLIENTE = LUSO.CDCLIENTE(+)
                       AND SERV.NRLICENCAUSO = LUSO.NRLICENCAUSO(+)
                       AND SERV.NRORG = PROP.NRORG(+)
                       AND SERV.NRPROPOSFAS = PROP.NRPROPOSFAS(+)
                       AND SERV.NRVERPROPFAS = PROP.NRVERPROPFAS(+)
                       AND SERV.NRORG = TPSV.NRORG(+)
                       AND SERV.CDTIPOSERV = TPSV.CDTIPOSERV(+)
                       AND SERV.NRORG = INTC.NRORG(+)
                       AND SERV.CDCLIENTE = INTC.CDCLIENTE(+)
                       AND SERV.CDINTECLIE = INTC.CDINTECLIE(+)
                       AND SERV.NRORG = INTP.NRORG(+)
                       AND SERV.CDPROSPECT = INTP.CDPROSPECT(+)
                       AND SERV.CDINTEPROS = INTP.CDINTEPROS(+)
                       AND SERV.NRORG = CONT.NRORG(+)
                       AND SERV.NRCONTATO = CONT.NRSEQCONTATO(+)
                       AND SERV.NRORG = EVOC.NRORG(+)
                       AND SERV.NRCONTATO = EVOC.NRSEQCONTATO(+)
                       AND SERV.DTHREVOLCONT = EVOC.DTHREVOLCONT(+)
                       AND SERV.CDEMPRESA = DSSP.CDEMPRESA(+)
                       AND SERV.CDFUNC = DSSP.CDFUNC(+)
                       AND SERV.CDCLIENTE = DSSP.CDCLIENTE(+)
                       AND SERV.DTSERVPREST = DSSP.DTSERVPREST(+)
                       AND SERV.NRSERVPREST = DSSP.NRSERVPREST(+)
                       AND SERV.NRORG = DSSP.NRORG(+)
                       AND CONT.NRORG = MOTC.NRORG(+)
                       AND CONT.CDMOTICONT = MOTC.CDMOTICONT(+)
                       AND EVOC.NRORG = MEVC.NRORG(+)
                       AND EVOC.CDMOTIEVOCON = MEVC.CDMOTIEVOCON(+)
                       AND :CDFUNC = :CDFUNC
                    ORDER BY TO_DATE(DATA, 'DD/MM/YYYY'), SERV.NRSERVPREST";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql, $params);
    }

    public function getFuncionarios()
    {
        
        $sql = "SELECT
                    OPER.CDOPERADOR,
                    OPER.NMOPERADOR,
                    FUNC.CDFUNC,
                    FUNC.NRORG,
                    FUNC.CDEMPRESA,
                    FUNC.CDFILIAL,
                    FUNC.CDTPADMISSAO,
                    FUNC.CDFUNC || ' - ' || OPER.NMOPERADOR AS DISPLAYFUNC
                FROM
                    FUNCIONARIO FUNC,
                    OPERADOR    OPER
                WHERE
                        FUNC.CDFUNC = OPER.CDFUNC";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }

    public function getPeriodoApuraPonto()
    {
        $sql = "SELECT DISTINCT
                    F.DTINICIALAPURAPONTO,
                    TO_CHAR(DTINICIALAPURAPONTO, 'DD/MM/YYYY') || ' - ' || TO_CHAR(DTFINALAPURAPONTO, 'DD/MM/YYYY') || DECODE(F.IDPERIODOAPURAPONTO, 'ABERTO', ' (Período aberto)', ' (Período fechado)') DISPLAY,
                    DECODE(F.IDPERIODOAPURAPONTO, 'ABERTO', '(Em aberto)', '(Fechado)') STATUS,
                    TO_CHAR(DTINICIALAPURAPONTO, 'DD/MM/YYYY') || ',' || TO_CHAR(DTFINALAPURAPONTO, 'DD/MM/YYYY') VALUE
                FROM 
                    FPA_PERIODOAPURAPONTO F
                WHERE 
                    F.DTINICIALAPURAPONTO <= TRUNC(SYSDATE)
                ORDER BY 
                    F.DTINICIALAPURAPONTO DESC";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }

    public function getClienteCda()
    {
        $sql = "SELECT
                    CLIENTE.CDCLIENTE     AS CDCLIENTE,
                    CLIENTE.NMRAZSOCCLIE  AS NMRAZSOCCLIE,
                    CLIENTE.NMFANTCLIE    AS NMFANTCLIE,
                    CLIENTE.NRINSJURCLIE  AS NRINSJURCLIE,
                    CLIENTE.NRORG         AS NRORG,
                    CLIENTE.NRPARCNEGOCIO AS NRPARCNEGOCIO,
                    CLIENTE.CDCLIENTE || ' - ' || CLIENTE.NMRAZSOCCLIE  AS DISPLAYCLIENTE
                FROM
                    CLIENTE ORDER BY NMRAZSOCCLIE";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }

    public function getRepresentante($params)
    {
        $sql = "SELECT
                    inteclie.cdinteclie   AS CDINTECLIE,
                    inteclie.nminteclie   AS NMINTECLIE,
                    inteclie.nrorg        AS NRORG,
                    inteclie.cdcliente    AS CDCLIENTE,
                    inteclie.dsemailiclie AS DSEMAILICLIE,
                    inteclie.nrfaxinclie  AS NRFAXINCLIE,
                    inteclie.nrtel1inclie AS NRTEL1INCLIE
                FROM
                    inteclie WHERE inteclie.cdcliente = :CDCLIENTE";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql, $params);
    }

    public function getPropostaCda($params)
    {
        $sql = "SELECT DISTINCT
                    A.NRPROPOSFAS || '-'|| A.NRVERPROPFAS AS NR_VER_PROP,
                    A.NRPROPOSFAS,
                    A.NRVERPROPFAS,
                    P.DSREFEPROPOSFAS,
                    A.NRORG,
                    A.CDFUNC,
                    C.CDCLIENTE,
                    A.NRPROPOSFAS || '-'|| A.NRVERPROPFAS || ' - ' || P.DSREFEPROPOSFAS AS DISPLAYPROPOSTA
                FROM
                    CLIENTE      C,
                    CONTRATOSERV CO,
                    AGENDASERV   A,
                    PROPOSTAFAS  P
                WHERE
                        A.NRORG = CO.NRORG
                    AND A.NRPROPOSFAS = CO.NRPROPOSFAS
                    AND A.NRVERPROPFAS = CO.NRVERPROPFAS
                    AND A.CDTIPOSERV = CO.CDTIPOSERV
                    AND A.NRSERVCONT = CO.NRSERVCONT
                    AND C.NRORG = CO.NRORG
                    AND C.CDCLIENTE = CO.CDCLIENTE
                    AND A.NRORG = P.NRORG
                    AND A.NRPROPOSFAS = P.NRPROPOSFAS
                    AND A.NRVERPROPFAS = P.NRVERPROPFAS
                    AND A.NRORG = :NRORG
                    AND A.CDFUNC = :CDFUNC
                    AND C.CDCLIENTE = :CDCLIENTE
                ORDER BY
                    A.NRPROPOSFAS";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql, $params);
    }

    public function getProjetoOperadorCliente($params)
    {
        $sql = "SELECT CDPROJETO, NMPROJETO, CDPROJETO || ' - '|| NMPROJETO AS DISPLAYPROJETO
                FROM (SELECT MAX(C.CDVERCRONPRJ) AS CDCRONO, P.NRORG, P.CDCLIENTE, C.CDOPERADOR,
                                C.CDNIVELITPRJ AS NIVEL, P.CDPROJETO, P.NMPROJETO
                        FROM PROJETO P, CRONOPROJETO C
                    WHERE P.NRORG = C.NRORG
                        AND P.CDFILIAL = C.CDFILIAL
                        AND P.CDPROJETO = C.CDPROJETO
                        AND C.CDOPERADOR = :CDOPERADOR
                        AND P.CDCLIENTE = :CDCLIENTE
                        AND P.NRORG = :NRORG
                        AND CDNIVELITPRJ = '3'
                    GROUP BY P.NRORG, P.CDCLIENTE, C.CDOPERADOR,P.CDPROJETO, C.CDNIVELITPRJ, C.CDOPERADOR, P.NMPROJETO
                    ORDER BY C.CDNIVELITPRJ DESC
                    ) PROJETO";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql, $params);
    }

    public function getTipoAtividadeCda($params)
    {
        $sql = "SELECT T.NMTIPOSERV, T.CDTIPOSERV, CO.CDCLIENTE, CO.NRPROPOSFAS, CO.NRVERPROPFAS,
                        CO.NRSERVCONT, CO.QTSERVCONT, A.NRORG, A.CDFUNC, T.CDTIPOSERV || ' - ' ||  T.NMTIPOSERV AS DISPLAYTIPOATIVIDADE
                FROM TIPOSERV T, CONTRATOSERV CO, AGENDASERV A
                WHERE (A.NRORG = CO.NRORG)
                    AND (A.NRVERPROPFAS = CO.NRVERPROPFAS)
                    AND (A.CDTIPOSERV = CO.CDTIPOSERV)
                    AND (A.NRSERVCONT = CO.NRSERVCONT)
                    AND (A.NRPROPOSFAS = CO.NRPROPOSFAS)
                    AND (CO.CDTIPOSERV = T.CDTIPOSERV)
                    AND (CO.NRORG = T.NRORG)
                    AND (CO.NRPROPOSFAS = :NRPROPOSFAS)
                    AND (CO.NRVERPROPFAS = :NRVERPROPFAS)
                    AND (CO.CDCLIENTE = :CDCLIENTE)
                    AND (CO.NRORG = :NRORG)
                    AND (A.CDFUNC = :CDFUNC)
                    AND (TO_DATE(:DTSERVPREST, 'DD/MM/YYYY') BETWEEN DTINITRASERV AND DTFINTRASERV)
                ORDER BY T.CDTIPOSERV";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql, $params);
    }

    public function getProspectCda()
    {
        $sql = "SELECT
                    PROSPECT.NRINSJURPROS  AS NRINSJURPROS,
                    PROSPECT.NMRAZSOCPROS  AS NMRAZSOCPROS,
                    PROSPECT.NRORG         AS NRORG,
                    PROSPECT.CDPROSPECT    AS CDPROSPECT,
                    PROSPECT.NRPARCNEGOCIO AS NRPARCNEGOCIO,
                    PROSPECT.CDPROSPECT  || ' - ' || PROSPECT.NMRAZSOCPROS AS DISPLAYPROSPECT
                FROM
                    PROSPECT ORDER BY NMRAZSOCPROS";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }

    public function getInterlocutorProspectCda($params)
    {
        $sql = "SELECT
                    INTEPROSP.CDINTEPROS   AS CDINTEPROS,
                    INTEPROSP.NMINTEPROS   AS NMINTEPROS,
                    INTEPROSP.NRORG        AS NRORG,
                    INTEPROSP.CDPROSPECT   AS CDPROSPECT,
                    INTEPROSP.NRTEL1INPROS AS NRTEL1INPROS,
                    INTEPROSP.DSEMAILIPROS AS DSEMAILIPROS,
                    INTEPROSP.CDINTEPROS || ' - ' || INTEPROSP.NMINTEPROS AS DISPLAYINTPROSPECT
                FROM
                    INTEPROSP WHERE CDPROSPECT = :CDPROSPECT";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql, $params);
    }

    public function getInterlocutorClienteCda($params)
    {
        $sql = "SELECT
                    INTECLIE.CDINTECLIE   AS CDINTECLIE,
                    INTECLIE.NMINTECLIE   AS NMINTECLIE,
                    INTECLIE.NRORG        AS NRORG,
                    INTECLIE.CDCLIENTE    AS CDCLIENTE,
                    INTECLIE.DSEMAILICLIE AS DSEMAILICLIE,
                    INTECLIE.NRFAXINCLIE  AS NRFAXINCLIE,
                    INTECLIE.NRTEL1INCLIE AS NRTEL1INCLIE,
                    INTECLIE.CDINTECLIE || ' - '|| INTECLIE.NMINTECLIE AS DISPLAYINTCLIENTE
                FROM
                    INTECLIE WHERE CDCLIENTE = :CDCLIENTE ORDER BY CDINTECLIE";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql, $params);
    }

    public function getLicencaUsoCda($params)
    {
        $sql = "SELECT
                    LICENCAUSO.CDCLIENTE    AS CDCLIENTE,
                    LICENCAUSO.NRLICENCAUSO AS NRLICENCAUSO,
                    LICENCAUSO.NRORG        AS NRORG,
                    LICENCAUSO.CDLOCALUSO   AS CDLOCALUSO,
                    LICENCAUSO.NMFANTLUSO   AS NMFANTLUSO,
                    LICENCAUSO.NMRAZSOCLUSO AS NMRAZSOCLUSO,
                    LICENCAUSO.CDLOCALUSO || ' - ' || LICENCAUSO.NMFANTLUSO AS DISPLAYLICENSAUSO
                FROM
                    LICENCAUSO
                WHERE LICENCAUSO.CDCLIENTE = :CDCLIENTE";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql, $params);
    }

    public function getContatoCda($params)
    {
        $sql = "SELECT
                    CONTATO.NRSEQCONTATO  AS NRCONTATO,
                    CONTATO.DSREFECONT    AS NMCONTATO,
                    CONTATO.CDOPERCONT    AS CDOPERCONT,
                    CONTATO.NRPARCNEGOCIO AS NRPARCNEGOCIO,
                    CONTATO.CDMOTICONT    AS CDMOTICONT,
                    CONTATO.DTHRCONTATO   AS DTHRCONTATO,
                    CONTATO.NRORG         AS NRORG,
                    CONTATO.CDFILIAL      AS CDFILIAL,
                    CONTATO.IDATIVO       AS IDATIVO,
                    PARC.NMPRINCIPALPARC  AS NRPARCNEGOCIO__LABEL,
                    CONTATO.NRSEQCONTATO || ' - ' || CONTATO.DSREFECONT AS DISPLAYCONTATO
                FROM
                        CONTATO
                    INNER JOIN PARCNEGOCIO PARC ON PARC.NRPARCNEGOCIO = CONTATO.NRPARCNEGOCIO
                                                AND PARC.NRORG = CONTATO.NRORG
                                                AND CONTATO.NRPARCNEGOCIO = :NRPARCNEGOCIO";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql, $params);
    }

    public function getMotivoEvoContCda()
    {
        $sql = "SELECT
                    MOTIEVOLCONT.CDMOTIEVOCON AS CDMOTIEVOCON,
                    MOTIEVOLCONT.NMMOTIEVOCON AS NMMOTIEVOCON,
                    MOTIEVOLCONT.NRORG        AS NRORG,
                    MOTIEVOLCONT.CDMOTIEVOCON || ' - ' || MOTIEVOLCONT.NMMOTIEVOCON AS DISPLAYMOTIVOEVOCONT
                FROM
                    MOTIEVOLCONT ORDER BY CDMOTIEVOCON";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }

    public function getMotivoContatoCda()
    {
        $sql = "SELECT
                    CDMOTICONT AS CODIGO,
                    NMMOTICONT AS DESCRICAO,
                    IDATIVO 
                FROM
                    MOTICONT WHERE IDATIVO = 'S'
                ORDER BY
                    NMMOTICONT";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }

    public function getSistemaCda()
    {
        $sql = "SELECT
                    CDSISTEMA AS CODIGO,
                    NMSISTEMA AS DESCRICAO,
                    IDTECNOSIST
                FROM
                    SISTEMA WHERE IDTECNOSIST = 'WEB'
                ORDER BY
                    NMSISTEMA";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }

    public function getMotivoJustificativaCda()
    {
        $sql = "SELECT
                    NRMOTIVOEXCEFREQ AS CODIGO,
                    NMMOTIVOEXCEFREQ AS DESCRICAO
                FROM
                    GPE_MOTIVOEXCEFREQ WHERE  NRMOTIVOEXCEFREQ < '100000' ORDER BY NRMOTIVOEXCEFREQ";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }

    public function getMotivoAfastamentoInssCda()
    {
        $sql = "SELECT
                    NRMOTIVOEXCEFREQ AS CODIGO,
                    NMMOTIVOEXCEFREQ AS DESCRICAO
                FROM
                    GPE_MOTIVOEXCEFREQ WHERE  NRMOTIVOEXCEFREQ > '100000' ORDER BY NRMOTIVOEXCEFREQ";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }


    public function getJustHorasNaoFaturadasCda()
    {
        $sql = "SELECT 
                    NRJUSTHORASNAOFATUCDA, 
                    DSJUSTHORASNAOFATUCDA 
                FROM JUSTHORASNAOFATUCDA";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }

    public function getServParticipantesCda()
    {
        $sql = "SELECT
                    NRSERVPRESTPARTICIP,
                    DSNOMEPARTICIP,
                    DSSETORPARTICIP
                FROM
                    SERVPRESTPARTICIP";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }

    public function consultaProxNrServPrest($params)
    {
        $sql = "SELECT TRIM(TO_CHAR(NVL(MAX(TO_NUMBER(SP.NRSERVPREST)), 0)+1, '00000')) AS NRSERVPREST
                FROM SERVPREST SP 
                WHERE SP.NRORG = :NRORG
                    AND SP.CDEMPRESA = :CDEMPRESA
                    AND SP.CDFUNC = :CDFUNC
                    AND SP.CDCLIENTE = :CDCLIENTE
                    AND SP.DTSERVPREST = TO_DATE(:DTSERVPREST, 'DD/MM/YYYY HH24:MI:SS')";
            
        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql, $params);
    }
    
    
    public function inserirAtividadeCda($parametros)
    {
        $sql = "INSERT INTO SERVPREST ( IDSERVPREST, NRMOTIVOEXCEFREQ, CDCLIENTE, CDINTECLIE, CDPROSPECT, CDINTEPROS, NMINTCLIENTE, NRLICENCAUSO, CDPROJETO, CDTIPOSERV, CDFUNC, DSREFERENCIA, DTSERVPREST, CDEMPRESA, IDSITSERVPREST, NRPROPOSFAS, NRSEQUCHT, NRSERVPREST, NRVERPROPFAS, NRCONTATO, DTHREVOLCONT, CDFILIAL, DTENTRADA, NRORG, NRORGINCLUSAO, CDOPERINCLUSAO, DTINCLUSAO, NRORGULTATU, CDOPERULTATU, DTULTATU, IDATIVO, NRSERVCONT, NRSEQAGESERV) 
        VALUES ( :IDSERVPREST, :NRMOTIVOEXCEFREQ, :CDCLIENTE, :CDINTECLIE, :CDPROSPECT, :CDINTEPROS, :NMINTCLIENTE, :NRLICENCAUSO, :CDPROJETO, :CDTIPOSERV,:CDFUNC, :DSREFERENCIA, :DTSERVPREST, :CDEMPRESA, :IDSITSERVPREST, :NRPROPOSFAS, :NRSEQUCHT, :NRSERVPREST, :NRVERPROPFAS, :NRCONTATO, :DTHREVOLCONT, :CDFILIAL, :DTENTRADA, :NRORG, :NRORGINCLUSAO, :CDOPERINCLUSAO, :DTINCLUSAO, :NRORGULTATU, :CDOPERULTATU, :DTULTATU, :IDATIVO, :NRSERVCONT, :NRSEQAGESERV)";
        $this->connection->executeStatement($sql, $parametros);
    }

    public function inserirParticipantesCda($parametros)
    {
        $sql = "INSERT INTO SERVPRESTPARTICIP ( NRSERVPRESTPARTICIP, DSNOMEPARTICIP, DSSETORPARTICIP, CDEMPRESA, CDFUNC, CDCLIENTE, DTSERVPREST, NRSERVPREST, IDATIVO, NRORG, DTINCLUSAO, NRORGINCLUSAO, CDOPERINCLUSAO) 
        VALUES ( :NRSERVPRESTPARTICIP, :DSNOMEPARTICIP, :DSSETORPARTICIP, :CDEMPRESA, :CDFUNC, :CDCLIENTE, :DTSERVPREST, :NRSERVPREST, :IDATIVO, :NRORG, SYSDATE, :NRORGINCLUSAO, :CDOPERINCLUSAO)";
        $this->connection->executeStatement($sql, $parametros);
    }

    public function atualizarAtividadeCda($parametros)
    {   
        $sql = "UPDATE SERVPREST
            SET NRMOTIVOEXCEFREQ = :NRMOTIVOEXCEFREQ,
                CDCLIENTE = :CDCLIENTE,
                CDINTECLIE = :CDINTECLIE,
                CDPROSPECT = :CDPROSPECT,
                CDINTEPROS = :CDINTEPROS,
                NRLICENCAUSO = :NRLICENCAUSO,
                CDPROJETO = :CDPROJETO,
                CDTIPOSERV = :CDTIPOSERV,
                MINTCLIENTE = :MINTCLIENTE,
                CDFUNC = :CDFUNC,
                DSREFERENCIA = :DSREFERENCIA,
                DTSERVPREST = :DTSERVPREST,
                CDEMPRESA = :CDEMPRESA,
                IDSITSERVPREST = :IDSITSERVPREST,
                NRPROPOSFAS = :NRPROPOSFAS,
                NRSEQUCHT = :NRSEQUCHT,
                NRSERVPREST = :NRSERVPREST,
                NRVERPROPFAS = :NRVERPROPFAS,
                NRCONTATO = :NRCONTATO,
                DTHREVOLCONT = :DTHREVOLCONT,
                CDFILIAL = :CDFILIAL,
                DTENTRADA = :DTENTRADA,
                NRORG = :NRORG,
                NRORGINCLUSAO = :NRORGINCLUSAO,
                CDOPERINCLUSAO = :CDOPERINCLUSAO,
                DTINCLUSAO = :DTINCLUSAO,
                NRORGULTATU = :NRORGULTATU,
                CDOPERULTATU = :CDOPERULTATU,
                DTULTATU = SYSDATE,
                IDATIVO = :IDATIVO,
                NRSERVCONT = :NRSERVCONT,
                NRSEQAGESERV = :NRSEQAGESERV
            WHERE
                IDSERVPREST = :IDSERVPREST";

        $this->connection->executeStatement($sql, $parametros);
    }

    public function getNrservcontAndNrseqageserv($params)
    {

        $sql = "SELECT AGE.NRSERVCONT, AGE.NRSEQAGESERV
                  FROM AGENDASERV AGE
                 WHERE AGE.NRPROPOSFAS  = :NRPROPOSFAS
                   AND AGE.NRVERPROPFAS = :NRVERPROPFAS
                   AND AGE.NRORG        = :NRORG
                   AND AGE.CDTIPOSERV   = :CDTIPOSERV
                   AND AGE.CDEMPRESA    = :CDEMPRESA
                   AND AGE.CDFUNC       = :CDFUNC
                   AND (TO_DATE(:DTSERVPREST, 'DD/MM/YYYY') BETWEEN AGE.DTINITRASERV AND AGE.DTFINTRASERV) 
                   AND ROWNUM = 1";
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();
        //return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql, $params);
    }

    public function getPermissaoOperadorCda($params)
    {
        $sql = "SELECT
                    OPG.CDGRUPOPER,
                    AUT.IDAUTGRUPOP
                FROM
                    OPERGRUPOP OPG,
                    AUTGRUPOP AUT
                WHERE
                    OPG.CDGRUPOPER = AUT.CDGRUPOPER
                    AND OPG.CDOPERADOR = :CDOPERADOR
                    AND OPG.NRORG = :NRORG";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql, $params);
    }

}
