<?php

namespace SM\Factory;

use Doctrine\ORM\EntityManager;
use SM\Traits\TQuery;

class Sm00054001ReducaoQuantidadeMedidaOperadorFactory
{

    use TQuery;

    protected $connection;

    protected $entityManager;

    public function __construct(EntityManager $entityManager)
    {
        $this->connection = $entityManager->getConnection();
        $this->entityManager = $entityManager;
    }

    public function getReducaoQuantidadeMedidaOperador()
    {

        $sql = "SELECT AL.NRALTERAQTMEDOPER,
                       AL.CDOPERADOR,
                       AL.IDATIVO,
                       AL.DTINCLUSAO,
                       AL.NRORGINCLUSAO,
                       AL.NRORG,
                       AL.CDOPERINCLUSAO,
                       AL.CDOPERULTATU,
                       AL.NRORGULTATU,
                       AL.DTULTATU,
                       OP.NMOPERADOR
                    FROM FCT_ALTERAQTMEDOPERADOR AL
                    JOIN OPERADOR OP ON AL.CDOPERADOR = OP.CDOPERADOR";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }

    public function validaReducaoOperador(array $params)
    {

        $sql = "SELECT COUNT (*) AS QTD
                FROM FCT_ALTERAQTMEDOPERADOR
                WHERE CDOPERADOR = :CDOPERADOR
                AND NRALTERAQTMEDOPER <> NVL(:NRALTERAQTMEDOPER,-1)";

        return $this->connection->executeQuery($sql, $params)->fetchAllAssociative();
    }

    public function inserirReducaoQuantidadeMedidaOperador($parametros)
    {
        $sql = "INSERT INTO  FCT_ALTERAQTMEDOPERADOR (
                NRALTERAQTMEDOPER, CDOPERADOR,NRORG, IDATIVO,
                DTINCLUSAO, NRORGINCLUSAO, 
                CDOPERINCLUSAO)
                VALUES (
                 :NRALTERAQTMEDOPER, :CDOPERADOR, :NRORG,  :IDATIVO,
                 SYSDATE, :NRORGINCLUSAO,:CDOPERINCLUSAO
                
                )";

        $this->connection->executeStatement($sql, $parametros);
    }

    public function atualizarReducaoQuantidadeMedidaOperador($parametros)
    {
        $sql = "UPDATE FCT_ALTERAQTMEDOPERADOR
                SET CDOPERADOR = :CDOPERADOR,
                    NRORG = :NRORG,
                    IDATIVO = :IDATIVO,
                    NRORGINCLUSAO = :NRORGINCLUSAO,
                    CDOPERINCLUSAO = :CDOPERINCLUSAO
                WHERE NRALTERAQTMEDOPER = :NRALTERAQTMEDOPER";

        $this->connection->executeStatement($sql, $parametros);
    }

    public function deletarReducaoQuantidadeMedidaOperador($parametros)
    {
        $sql = "DELETE FROM FCT_ALTERAQTMEDOPERADOR WHERE NRALTERAQTMEDOPER = :NRALTERAQTMEDOPER ";
        $this->connection->executeStatement($sql, $parametros);
    }
}
